
# PunchCommerce

The module is located in ./Web/app/code/Ecentral/PunchCommerce

## Installation

* **Option 1**:
Place module in path repository accessible to your magento installation and run
```composer require ecentral/module-punchcommerce```

* **Option 2**
Copy module files to app/code/Ecentral/PunchCommerce

No matter which option you chose, always run the following commands afterwards: 
```shell
bin/magento setup:upgrade
```
Depending on your deploy mode you might also have to run
```shell
bin/magento setup:di:compile
bin/magento setup:static-content:deploy
```
## Configuration

* Create Magneto customer and set a PunchCommerce identifier in the attribute " PunchCommerce Customer ID"
* Activate the module in Stores > Configuration > PunchCommerce > PunchCommerce Settings
* Define whether the user should be asked before refreshing the session and drop the cart.
* For running Punchout in an iFrame with OCI mode you have to set the configuration field "Frame Ancestor" to the domain that is providing the iframe. You may set multiple domains separated by spaces. 
* Adjust the product mapping according to the following rules. This documentation can also be found below the config field in the magneto backend.
```json
{
  "field1": {
    "type": <"map"(default. may be omitted) or "static">
    "target": <"product" or "item". Only used for type map. Sets product or quote item as mapping target>
    "value": <Literal value for type static or attribute code to be mapped from target>
  },
  "field2": {
    ...
  },
  ...
}
Must contain definitions for fields: brand, price, tax_rate, purchase_unit, packaging_unit, shipping_time
```
* Set the Hook Url to point to your PunchCommerce Server instance. You only have to adjust this value if you are hosting your own PunchCommerce server.

## Troubleshooting

Depending on the webserver you are using to run magneto you might have to adjust the server config to run PunchCommerce in OCI mode.
### Apache
You have to remove/comment line 289 from pub/.htaccess 
```Header set X-Frame-Options SAMEORIGIN```. This line prevents the site from loading in iFrames.

### Nginx
**Untested**
The following line might prevent the site from loading in iFrames:
```add_header X-Frame-Options "SAMEORIGIN";```


